diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
index f31fb2020..60da91151 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
@@ -1,118 +1,120 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicLadder extends BlockLogic implements ISupportable {
 
-	public BlockLogicLadder(@NotNull Block<?> block) {
-		super(block, Material.wood);
-	}
-	
-	@Override
-	public boolean isSolidRender() {
-		return false;
-	}
-	
-	@Override
-	public boolean isCubeShaped() {
-		return false;
-	}
-
-	@Override
-	public boolean isClimbable(@NotNull World world, @NotNull TilePos tilePos) {
-		return true;
-	}
-
-	@Override
-	public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
-		return PartialSupport.INSTANCE;
-	}
-
-	@Override
-	public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
-		Side side = getSideFromMeta(source.getBlockData(tilePos));
-
-		float width = 3.0f / 16.0f;
+    public BlockLogicLadder(@NotNull Block<?> block) {
+        super(block, Materials.WOOD);
+    }
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    @Override
+    public boolean isCubeShaped() {
+        return false;
+    }
+
+    @Override
+    public boolean isClimbable(@NotNull World world, @NotNull TilePosc tilePos) {
+        return true;
+    }
+
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
+    @Override
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        Side side = getSideFromMeta(source.getBlockData(tilePos));
+
+        float width = 3.0f / 16.0f;
         return switch (side) {
-            case SOUTH -> AABB.fromPool(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, width);
-            case WEST -> AABB.fromPool(1.0f - width, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
-            case EAST -> AABB.fromPool(0.0f, 0.0f, 0.0f, width, 1.0f, 1.0f);
-            default -> AABB.fromPool(0.0f, 0.0f, 1.0f - width, 1.0f, 1.0f, 1.0f);
+            case SOUTH -> new AABBd(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, width);
+            case WEST -> new AABBd(1.0f - width, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
+            case EAST -> new AABBd(0.0f, 0.0f, 0.0f, width, 1.0f, 1.0f);
+            default -> new AABBd(0.0f, 0.0f, 1.0f - width, 1.0f, 1.0f, 1.0f);
         };
-	}
-
-	@Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
-		if(!canExistAt(world, tilePos, world.getBlockData(tilePos))) {
-			dropWithCause(world, EnumDropCause.WORLD, tilePos, id, null, null);
-			world.setBlockIdNotify(tilePos, 0);
-		}
-	}
-
-	@Override
-	public final boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos) {
-		// Unused, check ItemBlockLadder
-		return true;
-	}
-
-	@Override
-	public boolean canPlaceOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
-		// Unused, check ItemBlockLadder
-		return true;
-	}
-
-	public Side getSideForPlacement(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side clickedSide) {
-		TilePos p = tilePos;
-		if(!world.canPlaceInsideBlock(tilePos)) {
-			p = p.add(clickedSide.getDirection());
-		}
-
-		if(canExistAt(world, p, getMetaForSide(clickedSide))) return clickedSide;
-		if(canExistAt(world, p, getMetaForSide(Side.NORTH))) return Side.NORTH;
-		if(canExistAt(world, p, getMetaForSide(Side.SOUTH))) return Side.SOUTH;
-		if(canExistAt(world, p, getMetaForSide(Side.WEST))) return Side.WEST;
-		if(canExistAt(world, p, getMetaForSide(Side.EAST))) return Side.EAST;
-		
-		return null;
-	}
-	
-	public boolean canExistAt(@NotNull World world, @NotNull TilePos tilePos, int meta) {
-		Side side = getSideFromMeta(meta).getOpposite();
-		return isSupported(world, tilePos, side);
-	}
-
-	/**
-	 * Returns the side of the block the ladder is attached to
-	 */
-	public Side getSideFromMeta(int meta) {
-		if(meta == 2) return Side.NORTH;
-		if(meta == 3) return Side.SOUTH;
-		if(meta == 4) return Side.WEST;
-		if(meta == 5) return Side.EAST;
-		return Side.NONE;
-	}
-	
-	public int getMetaForSide(@NotNull Side side) {
-		if(side == Side.NORTH) return 2;
-		if(side == Side.SOUTH) return 3;
-		if(side == Side.WEST) return 4;
-		if(side == Side.EAST) return 5;
-		return 0;
-	}
-
-	@Override
-	public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
-		return FullSupport.INSTANCE;
-	}
+    }
+
+    @Override
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+        if (!canExistAt(world, tilePos, world.getBlockData(tilePos))) {
+            dropWithCause(world, EnumDropCause.WORLD, tilePos, id, null, null);
+            world.setBlockIdNotify(tilePos, 0);
+        }
+    }
+
+    @Override
+    public final boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        // Unused, check ItemBlockLadder
+        return true;
+    }
+
+    @Override
+    public boolean canPlaceOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        // Unused, check ItemBlockLadder
+        return true;
+    }
+
+    public Side getSideForPlacement(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side clickedSide) {
+        TilePosc p = tilePos;
+        if (!world.canPlaceInsideBlock(tilePos)) {
+            p = p.add(clickedSide.getDirection(), new TilePos());
+        }
+
+        if (canExistAt(world, p, getMetaForSide(clickedSide))) return clickedSide;
+        if (canExistAt(world, p, getMetaForSide(Side.NORTH))) return Side.NORTH;
+        if (canExistAt(world, p, getMetaForSide(Side.SOUTH))) return Side.SOUTH;
+        if (canExistAt(world, p, getMetaForSide(Side.WEST))) return Side.WEST;
+        if (canExistAt(world, p, getMetaForSide(Side.EAST))) return Side.EAST;
+
+        return null;
+    }
+
+    public boolean canExistAt(@NotNull World world, @NotNull TilePosc tilePos, int meta) {
+        Side side = getSideFromMeta(meta).getOpposite();
+        return isSupported(world, tilePos, side);
+    }
+
+    /**
+     * Returns the side of the block the ladder is attached to
+     */
+    public Side getSideFromMeta(int meta) {
+        if (meta == 2) return Side.NORTH;
+        if (meta == 3) return Side.SOUTH;
+        if (meta == 4) return Side.WEST;
+        if (meta == 5) return Side.EAST;
+        return Side.NONE;
+    }
+
+    public int getMetaForSide(@NotNull Side side) {
+        if (side == Side.NORTH) return 2;
+        if (side == Side.SOUTH) return 3;
+        if (side == Side.WEST) return 4;
+        if (side == Side.EAST) return 5;
+        return 0;
+    }
+
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return FullSupport.INSTANCE;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
index 3cc5a6d51..f4ff9f0f6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -10,7 +10,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -19,13 +19,13 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     public boolean isInverted;
 
     public BlockLogicLamp(Block<?> block, boolean isActive, boolean isInverted) {
-        super(block, Material.stone);
+        super(block, Materials.STONE);
         this.isActive = isActive;
         this.isInverted = isInverted;
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         if (this.isInverted) {
             if (this.isActive && (world.hasDirectSignal(tilePos) || world.hasNeighborSignal(tilePos))) {
                 world.setBlockIdDataNotify(tilePos, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockData(tilePos));
@@ -38,7 +38,7 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if (world.isClientSide) {
             return;
         }
@@ -61,7 +61,7 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         final boolean hasSignal = world.hasDirectSignal(tilePos) || world.hasNeighborSignal(tilePos);
 
         if (this.isInverted) {
@@ -80,7 +80,7 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (player.getHeldItem() == null) {
             invertLamp(world, tilePos);
             return true;
@@ -89,11 +89,11 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     }
 
     @Override
-    public void onActivatorInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
+    public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
         invertLamp(world, tilePos);
     }
 
-    public void invertLamp(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void invertLamp(final @NotNull World world, final @NotNull TilePosc tilePos) {
         if (this.isInverted) {
             if (this.isActive) {
                 world.setBlockIdDataNotify(tilePos, Blocks.LAMP_IDLE.id(), world.getBlockData(tilePos));
@@ -111,7 +111,7 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
 
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
-        return new ItemStack[] { new ItemStack(Blocks.LAMP_IDLE, 1, data) };
+        return new ItemStack[]{new ItemStack(Blocks.LAMP_IDLE, 1, data)};
     }
 
     @Override
@@ -130,7 +130,7 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     }
 
     @Override
-    public void removeDye(@NotNull World world, @NotNull TilePos tilePos) {
+    public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
         world.setBlockDataNotify(tilePos, 0);
     }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
index db1cb0498..f049d9d2f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
@@ -12,12 +13,14 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 import java.util.function.Supplier;
@@ -29,51 +32,48 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
     private final MobFireflyCluster.FireflyColor color;
 
     public BlockLogicLanternFirefly(@NotNull Block<?> block, @NotNull MobFireflyCluster.FireflyColor colour, @NotNull Supplier<Item> itemSupplier) {
-        super(block, Material.glass);
+        super(block, Materials.GLASS);
         this.color = colour;
         this.itemSupplier = itemSupplier;
         setBlockBounds(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.5f, 1 - 0.3125f);
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int metadata = source.getBlockData(tilePos);
         float offset = 0.0F;
         if ((metadata & MASK_HANGING) != 0)
             offset = 0.3875F;
-        return AABB.fromPool(0.3125f, offset,  0.3125f, 1 - 0.3125f, 0.5F + offset, 1 - 0.3125f);
+        return new AABBd(0.3125f, offset, 0.3125f, 1 - 0.3125f, 0.5F + offset, 1 - 0.3125f);
     }
 
     @Override
-    public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-    public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
-        if(rand.nextInt(3)==0) {
-            world.spawnParticle(this.color.getParticleName(), (double)tilePos.x + rand.nextFloat(), (double)tilePos.y + rand.nextFloat(), (double) tilePos.z + rand.nextFloat(), 0.0D, 0.0D, 0.0D, 0);
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        if (rand.nextInt(3) == 0) {
+            world.spawnParticle(this.color.getParticleName(), (double) tilePos.x() + rand.nextFloat(), (double) tilePos.y() + rand.nextFloat(), (double) tilePos.z() + rand.nextFloat(), 0.0D, 0.0D, 0.0D, 0);
         }
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         world.setBlockIdRaw(tilePos, 0);
         world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
-        if (!world.isClientSide)
-        {
+        if (!world.isClientSide) {
             world.dropItem(tilePos, new ItemStack(this.itemSupplier.get(), 1, 0));
         }
         world.markBlockDirty(tilePos);
@@ -82,16 +82,16 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
-        if ((side == Side.BOTTOM || (side != Side.TOP && yHit >= 0.5d)) && (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up()), BlockTags.CAN_HANG_OFF))){
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+        if ((side == Side.BOTTOM || (side != Side.TOP && yHit >= 0.5d)) && (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF))) {
             world.setBlockDataNotify(tilePos, MASK_HANGING);
             return;
         }
-        if ((side == Side.TOP || (side != Side.BOTTOM && yHit < 0.5d)) && isSupported(world, tilePos, Side.BOTTOM)){
+        if ((side == Side.TOP || (side != Side.BOTTOM && yHit < 0.5d)) && isSupported(world, tilePos, Side.BOTTOM)) {
             world.setBlockDataNotify(tilePos, 0);
             return;
         }
-        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up()), BlockTags.CAN_HANG_OFF)) {
+        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF)) {
             world.setBlockDataNotify(tilePos, MASK_HANGING);
         } else {
             world.setBlockDataNotify(tilePos, 0);
@@ -99,8 +99,8 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
     }
 
     @Override
-    public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos) {
-        if(isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up()), BlockTags.CAN_HANG_OFF)) {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF)) {
             return true;
         }
 
@@ -108,9 +108,8 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
-        if(!canStay(world, tilePos))
-        {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+        if (!canStay(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
         }
@@ -125,38 +124,38 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
     }
 
     @Override
-    public boolean canStay(@NotNull World world, @NotNull TilePos tilePos) {
+    public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
-        if((meta & MASK_HANGING) != 0) {
-            return isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up()), BlockTags.CAN_HANG_OFF);
+        if ((meta & MASK_HANGING) != 0) {
+            return isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF);
         }
 
         return isSupported(world, tilePos, Side.BOTTOM);
     }
 
     @Override
-    public void onDestroyedByPlayer(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, int data, @NotNull Player player, @Nullable Item item) {
-        if(item != null && item.isSilkTouch()) {
+    public void onDestroyedByPlayer(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, int data, @NotNull Player player, @Nullable Item item) {
+        if (item != null && item.isSilkTouch()) {
             return;
         }
-        if(!world.isClientSide) {
+        if (!world.isClientSide) {
             MobFireflyCluster entity = new MobFireflyCluster(world);
             entity.setColor(this.color);
             entity.setFireflyCount(1);
             entity.setClusterSize(0);
             entity.setSizeBasedOnClusterSize(entity.getClusterSize());
-            entity.setPos(tilePos.x + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f, tilePos.y + world.rand.nextFloat() * 0.5f, tilePos.z + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f);
+            entity.setPos(tilePos.x() + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f, tilePos.y() + world.rand.nextFloat() * 0.5f, tilePos.z() + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f);
             world.entityJoinedWorld(entity);
         }
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
     @Override
-    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return side.isVertical() ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
index 46bcde131..aa6cc9852 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
@@ -7,6 +7,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -20,13 +21,13 @@ public class BlockLogicLayerAsh extends BlockLogicLayerBase
         block.setTicking(true);
     }
 
-    public void accumulate(@NotNull World world, @NotNull TilePos tilePos) {
+    public void accumulate(@NotNull World world, @NotNull TilePosc tilePos) {
         int myMetadata = world.getBlockData(tilePos);
         if (myMetadata == 0x7) return;
 
         for (int i = 0; i < Direction.horizontalDirections.length; i++) {
             Direction dir = Direction.horizontalDirections[i];
-            TilePos dirPos = tilePos.add(dir);
+            TilePos dirPos = tilePos.add(dir, new TilePos());
             if (!((world.isBlockOpaqueCube(dirPos)) || (world.getBlockId(dirPos) == this.block.id() && world.getBlockData(dirPos) >= myMetadata))) return;
         }
 
@@ -35,8 +36,8 @@ public class BlockLogicLayerAsh extends BlockLogicLayerBase
     }
 
     @Override
-	public boolean canPlaceAt(World world, @NotNull TilePos tilePos) {
-        TilePos down = tilePos.down();
+	public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos down = tilePos.down(new TilePos());
         Block<?> b = world.getBlock(down);
         if(b == null || !b.isSolidRender()) {
         	return false;
@@ -47,7 +48,7 @@ public class BlockLogicLayerAsh extends BlockLogicLayerBase
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         // Remove if no longer valid
         if (!canPlaceAt(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
index a7d9d5022..a0d8de9dc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
@@ -6,12 +6,13 @@ import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.item.block.ItemBlockLayer;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public abstract class BlockLogicLayerBase extends BlockLogic
 {
@@ -39,7 +40,7 @@ public abstract class BlockLogicLayerBase extends BlockLogic
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int height = world.getBlockData(tilePos) & MASK_HEIGHT;
         return switch (side) {
             case TOP -> PartialSupport.INSTANCE;
@@ -57,9 +58,9 @@ public abstract class BlockLogicLayerBase extends BlockLogic
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int data = source.getBlockData(tilePos) & MASK_HEIGHT;
         float f = (float)(2 * (1 + data)) / 16F;
-        return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
+        return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
     }
 }
